<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Nightly Loop Test</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">Nightly Loop Test</H1>

        <H2>Test Objectives</H2>
		<UL>
		<LI>To test ldas handling of continuous job streams of various user commands esp. those used
        at production sites:
            <ul><font color='brown'>
            <li>createRDS</li>
            <li>dmt trigger insertion</li>  
            <li>dataStandAlone/putStandAlone</li>
            <li>getMetaData</li>
            <li>putMetaData</li>
            <li>conditionData</li>
            <li>getFrameCache</li> 
            <li>getFrameData</li> 
            <li>rmJobFiles</li>
            </ul>
            </LI></font>	
		</UL><p>
       
        <H2>Setup</H2>
        <ul>
        <li>LDASJob package from ligotools is required for running this test. Check that either package is mounted. <p>
        <font color='magenta'>Note: currently the scripts on dev are set up to use a modified version of ligotools that supports globus sockets so
        the ligotools package used is installed at <b>ldas-dev:/export/ldcg_server/mlei/ligotools</b>, with the following included in <b>~ldas/.cshrc</b>
        to support this package <pre><font color='brown'>eval `/export/ldcg_server/mlei/ligotools/bin/use_ligotools`.</pre></font> The environment
        variable <b>LIGOTOOLS</b> is set to <b>/export/ldcg_server/mlei/ligotools</b> as a result.</font></li><p>
        If ligotools is not installed, the scripts can be modified to use LDASJob package from the ldas installation by including <b>/ldas/lib</b>
        in the auto_path: e.g.<pre><font color='brown'>pipeloop.tcl: set ::auto_path "/ldas/lib . $auto_path"</font></pre>
        
        <li>Install the following tests script in a directory the ldas system common to all API hosts, e.g. <b>/ldas_usr/ldas/test/bin</b>
		<UL>Main Test scripts and resource files (under construction)<p>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/AllTest.rsc?rev=HEAD;content-type=text%2Fplain'><b>AllTest.rsc</b> - Resource configuration</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/startAllTest?rev=HEAD;content-type=text%2Fplain'><b>startAllTest</b> - start all the tests</a></font>
			<ul>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/pipeloop-all.all?rev=HEAD;content-type=text%2Fplain'>pipeloop-all.all - data/putStandAlone main driver</a></font>
            	<ul>
               		<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/pipeloop.tcl?rev=HEAD;content-type=text%2Fplain'>pipeloop.tcl - driver of each user cmd</a></font></li>
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/wait.tcl?rev=HEAD;content-type=text%2Fplain'>wait.tcl - sets the delay between each looper</a></font></li>
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/wait.tcl?rev=HEAD;content-type=text%2Fplain'>pause.tcl - pause the loopers</a></font></li>
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/cont.tcl?rev=HEAD;content-type=text%2Fplain'>cont.tcl - resumes the loopers</a></font></li
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stop.tcl?rev=HEAD;content-type=text%2Fplain'>stop.tcl - stops and exits all loopers</a></font></li>
                </ul></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/rundmt.tcl?rev=HEAD;content-type=text%2Fplain'>rundmt.tcl - dmt main driver</a></font>
            	<ul>
                	<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/cleandmt.tcl?rev=HEAD;content-type=text%2Fplain'>cleandmt.tcl - cleanup dmt data/process to start next run</a></font></li>
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/deltriggers.tcl?rev=HEAD;content-type=text%2Fplain'>deltriggers.tcl - delete triggers from database</a></font></li>
                    <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/insertTrigsLoop.test?rev=HEAD;content-type=text%2Fplain'>insertTrigsLoop.test - driver to submit jobs to SeqInsert</a></font></li>
                </ul>
            </li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/startrds.tcl?rev=HEAD;content-type=text%2Fplain'>startrds.tcl - createRDS main driver</a></font></li>
            	<ul>     
                 <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/dords_loop.s5?rev=HEAD;content-type=text%2Fplain'>dords_loop.s5 - maintains repeated runs of a createRDS test</a></font></li>
                 	<ul>
                    	<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/rdsloop_s5.tcl?rev=HEAD;content-type=text%2Fplain'>rdsloop_s5.tcl - submits a set of createRDS jobs within a time range</a></font></li>
                    	<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/rdsclean.tcl?rev=HEAD;content-type=text%2Fplain'>rdsclean.tcl - remove output frames so test can be re-run</a></font></li>					
                    </ul>
				</ul>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/loopcmd.test?rev=HEAD;content-type=text%2Fplain'>loopcmd.test - any loop cmd driver</a></font>
            	<ul>
                	<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/onejob.tcl?rev=HEAD;content-type=text%2Fplain'>onejob.tcl - submit one job to ldas and waits for return</a></font></li> 
                </ul>                   
            </li>       	
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/getFrameData.test?rev=HEAD;content-type=text%2Fplain'>getFrameData.test - loop cmd driver for getFrameData, also use onejob.tcl</a></font></li>
		</UL></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stopAllTest?rev=HEAD;content-type=text%2Fplain'><b>stopAllTest</b> - stop all the tests, remove old logs and exit test drivers</a></font></li>
      	</ul><p>
     	<UL>The following types of data files are needed by test scripts:<p>
        	<li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/adcdecimate_H-H2-RDS_R_L4-S5.txt?rev=HEAD;content-type=text%2Fplain'>createRDS channel files (e.g. adcdecimate_H-H2-RDS_R_L4-S5.txt )</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/getFrameData.cmd?rev=HEAD;content-type=text%2Fplain'>user command files (e.g. getFrameData.cmd)</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/knownpulsardemod-data.rds?rev=HEAD;content-type=text%2Fplain'>user command files for dataStandAlone (e.g. knownpulsardemod-data.rds)</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/stackslide-put.cmd?rev=HEAD;content-type=text%2Fplain'>user command files for putStandAlone (e.g. stackslide-put.cmd)</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/earth00-04.ilwd?rev=HEAD;content-type=text%2Fplain'>ilwd specifications needed by dataStandAlone (e.g. earth00-04.ilwd)</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/test/System/loop/leapseconds?rev=HEAD;content-type=text%2Fplain'>leapseconds file for gps time conversion</a></font></li>
            <li><CODE><font color='blue'><a href='http://ldas-sw.ligo.caltech.edu/cgi-bin/cvsweb.cgi/ldas/api/metadataAPI/tcl/test/xmlist?rev=HEAD;content-type=text%2Fplain'>xml file list for dmt</a></font></li>
            <li><CODE>S5 frame files must be mounted on ldas system and known to diskcacheAPI</li>
        </UL>    
        </ul>
        <H2>Test Execution</H2>
        <ol>
		<li>Login to site gateway box e.g. dev, as user ldas</li>
		<li>cd &lt;your workdir directory&gt; e.g. /ldas_outgoing/test; a local resource AllTest.rsc may be present to overide settings in the standard &lt;AllTest.rsc.&gt;</li>
        <li>To start all tests <B>usage:</B> <CODE>startAllTest &lt;site&gt; &</CODE><p>
		<p>e.g. on dev<pre><font &nbsp;color='brown'>startAllTest dev &</font></pre>
        <li>To stop all tests <B>&nbsp;usage:</B> <CODE>stopAllTest &lt;site&gt; &</CODE><p>
		<p>e.g. on dev<pre><font color='brown'>stopAllTest &</font></pre><p>
        It would take a few minutes for the scripts to all terminate as some of the createRDS jobs takes longer time to complete before the tests can exit.
		<p>
        </ol>
        <H2><a name="TestReport">Test Report Generation</a></H2>
        <ol>
		<li>Bring up cmonClient</li>
		<li>Hit <b>Jobs</b> page tab.</li>
        <li>Hit <b>Test Report</b> page tab.</li>
        <li>Select the time period on the left side. If it is a Monday, cmonClient will prompt the user for archiving the report.</li>
        <li>You can check if cntlmon is working on the report by viewing cntlmon logs.</li>
        <li>The finished report is displayed on your web browser as a new tab.</li>
        <li>Review the logs to fill in details not covered by log filtering. &nbsp;Additional patterns can be added to cntlmon resources:<p>
        <pre><b>::DISKCACHE_LOG_PATTERNS</b> for diskcache logs and <b>::KNOWN_ERRS_LOG_DESC</b> for non-diskcache logs</pre></li>
    </BODY>
</HTML>
